\section{Distributed fuzzing}

The total number of found bugs is roughly equal to the probability of discovering a single bug times the number of bugs present in the program \cite{ben_nagy_windows_2013}. Therefore, to find as many bugs as possible, the tester must either increase the likelihood of finding a bug or increase the number of performed tests (e.g. increasing computing capacity) \cite[p.~242]{fuzzing_miller}. The likelihood of finding a bug can be increased by writing a custom fuzzer that targets a concrete program feature (e.g. fuzzer for a specific image format parser). Designing a custom fuzzer for a specific format requires extra developer time, unlike ready-made general-purpose fuzzers. Custom fuzzer also makes fewer tests per second as the mutations are more complex and take longer time than in a general-purpose fuzzer (which usually makes only simple bitflips, byte insertions or removals and the likes). The other approach to finding more bugs is to run more tests. Increasing the number of tests can be done by making the fuzzer scalable and running the fuzzer on multiple nodes \cite[p.~243]{fuzzing_miller}. Distributed fuzzing is Google's approach in the ClusterFuzz \cite{clusterfuzz} and OSS-Fuzz \cite{oss-fuzz} projects.

\section{ClusterFuzz}

Google initially designed ClusterFuzz to fuzz their Chrome web \linebreak browser on a scale. It is not a new fuzzer in itself but an automated infrastructure built around already available fuzzers. In order to scale fuzz testing, it is not enough to scale just the number of CPU cores. The fuzzing process also requires more human resources.

When fuzzing on a scale, more work must be spent on writing more fuzz targets (small programs passing input from the fuzzer to the tested software component). The identical root cause may trigger similar crashes, and the inputs causing the crashes will usually be complex and unnecessarily extensive. The increased number of crashes and their complexity and superfluousness will increase the required time to triage and fix them. After they are triaged, the tester needs to file bug reports to the development team via an issue tracker, wait for the fix and test its correctness using the triggering input. Finally, the triggering input should be incorporated into regression testing procedures and verified continuously. All the beforementioned steps require extra time from the tester and developer, which is linearly dependent on the increased number of crash reports. Therefore the whole fuzzing lifecycle should be automated as much as possible to save time \cite{clusterfuzz_talk}. The ClusterFuzz project automates the whole fuzzing process apart from the fuzz target development and bug fixing.

The first step to fuzzing is writing fuzz targets. Often developers are better at writing fuzz targets than security engineers because they know the code and identify potential attack vectors better. It is essential to provide them with documentation and examples on writing fuzz targets. After writing the fuzz targets, they have to be built for fuzzing. The best option is to build them with compile-time instrumentation (i.e. address, memory and coverage sanitisers) that does not incur significant run-time performance penalties. The optimisation level should not be too high because it could interfere with the code-coverage tracking. It also should not be completely disabled, or the target would be too slow. It is recommended to use release build to disable noisy debug output and assertions and get as close to real-world usage as possible \cite{clusterfuzz_talk}.

After the fuzz targets are built, they are run on a cluster based on the Google Cloud Platform \cite{clusterfuzz-arch,gcp}. It consists of a pool of interruptible fuzzing bots, a persistent database for corpus storage, a task queue and non-interruptible virtual machines (VM) responsible for deduplication and minimisation of crashing inputs. Interruptible virtual machines are used for fuzzing because they are cheaper, and the fuzzer saves the generated inputs into the persistent corpus database. As the fuzzing bots work in parallel, the same or similar inputs can be saved into the corpus database. Therefore so-called \textit{corpus pruning} must be performed periodically. It is a process that reduces the size of the corpus while keeping the coverage of the old (larger) corpus. During the corpus pruning, cross-pollination from other corpora can happen (e.g. from different fuzzers or the same fuzzer used on a different library for the same file format), or some inputs may be quarantined. We have to quarantine inputs triggering already discovered but not yet fixed vulnerabilities (to let the fuzzer find new bugs until the vulnerability is fixed) \cite{clusterfuzz_talk}.

ClusterFuzz supports both gray and black-box fuzzing. Gray-box fuzzing is recommended for small, self-contained and deterministic targets (like unit tests). The target should be capable of executing tens to hundreds of times per second. An example of an ideal target for a gray-box fuzzer is a file format parser. On the other hand, black-box fuzzers are more suitable for slow, complex targets consisting of multiple components and behave non-deterministically (i.e. can give different results for the same inputs) \cite{clusterfuzz-black-vs-gray}. An example is rendering a web page from a network server using a web browser or compiling a source code to a binary program.

Different search strategies can be used when fuzzing. The coverage-guided fuzzers mutate the inputs to maximise code coverage. The \texttt{libfuzzer} \cite{libfuzzer} engine also supports additional modes. One of the modes is value profiling of compare instruction operands to get past constant magic values \cite{value_profile}. The entropic strategy looks at the fuzzing process as a learning process, where each test case reveals new information about the target program behaviour. The entropy of the gained information is measured and maximised \cite{entropic}. Structure-aware fuzzing uses a custom mutator to perform format-specific mutations. ClusterFuzz also supports mutating the corpus using a machine learning mutator \cite{clusterfuzz_talk} or a black-box fuzzer like radamsa \cite{radamsa}.

Every mentioned fuzzing strategy gives mixed results for different targets. Therefore one of the tasks when fuzzing on a scale is to schedule the fuzzers such that the most efficient strategy for the given target gets the most CPU time. In probability theory, this task is known as the multi-armed bandit problem \cite{MAB,clusterfuzz_talk}. The solution used in ClusterFuzz is to keep statistics about the increase of code coverage by the specific fuzzer in the current time frame. The most efficient fuzzers in the current time frame are given the most time in the next frame.

When a bug is discovered, it is automatically categorised. Firstly, the bugs are deduplicated. Every bug has to have an identifier to allow deduplication. The identifier consists of three function names from the stack trace (after filtering logging and standard library functions). Then bugs with a similar identifier are grouped because the same bugs can manifest in different contexts. String distance is used for bug grouping, which has been shown effective in real-world cases \cite{clusterfuzz_talk}.

The test cases triggering the bug are automatically minimised to simplify debugging and fixing for the developer. Gray-box fuzzers (like libfuzzer \cite{libfuzzer} or AFL \cite{afl}) usually already contain this functionality built-in. ClusterFuzz also contains a delta-debugging method (based on removing portions of the input until a minimal input is found) for minimising test cases discovered by black-box fuzzers \cite{clusterfuzz_talk}.

Ideally, the ClusterFuzz is a part of the continuous integration system, and fuzzers are built for (almost) every commit in the version control system. When a binary of the fuzz target is available for each commit, ClusterFuzz can automatically use binary search to locate the exact commit that introduced the bug. A bug is then filed into an issue tracker with all the collected metadata. The crashing input is added to the corpus and tested periodically, even after fixing it. Automatic bug verification eliminates possible human errors. Once the issue is fixed, the bug is automatically closed in the issue tracker. Again, a binary search is used to pinpoint the exact commit that fixed the issue
\cite{clusterfuzz_talk}.

ClusterFuzz also supports visualising code coverage to check that the fuzzer covers the expected code locations and to identify uncovered lines to help create new fuzz targets. The coverage metadata is not collected during fuzzer execution. The fuzz targets are usually compiled with coverage and memory or address sanitisers. However, to generate coverage report, they are recompiled with coverage sanitiser. Every input from the corpus is passed to the corresponding fuzz target, and a coverage report for the individual input is generated. Finally, all coverage reports are merged to produce a complete report for the whole corpus.

\section{OSS-Fuzz}

Open-source software powers a large part of the internet. Therefore it must be appropriately secured. Memory corruption bugs in widely used open-source software can have a significant security impact on a vast number of users. Fuzz testing can discover many of them, even those easily missed by a code audit. Google decided to give open-source access to its distributed ClusterFuzz environment and infrastructure to run the fuzzers on \cite{oss-fuzz-announcing}. Currently, the OSS-Fuzz project has discovered 39167 bugs \cite{oss-fuzz-issues} and fuzzes 580 open-source projects \cite{oss-fuzz-github}.

An open-source project has to be described in \texttt{project.yml} in order to be fuzzed using OSS-Fuzz. The file contains information about the project's homepage, used programming language, contact emails for reporting found bugs, source code repository URL, and the lists of sanitisers and CPU architectures which should be used during fuzzing. Some sanitisers can be marked as experimental when the project does not yet fully support them. For example, a memory sanitiser requires all the project dependencies to be recompiled with a memory sanitiser to function correctly. When the fuzzer is marked as experimental, the discovered bugs are not submitted to the issue tracker \cite{oss-fuzz-setting}. Once the \texttt{project.yml} is prepared, a pull request must be sent to the OSS-Fuzz repository \cite{oss-fuzz-github}. An example \texttt{project.yml} is shown on Figure-\ref{fig:project_yml}.

\input{figures/project_yml.tex}

Once the pull request is accepted, the code for fuzz targets can be submitted. OSS-Fuzz builds and runs fuzz targets using Docker containers \cite{docker}. The builder image is defined using a  \texttt{Dockerfile} which describes how to install and download all the dependencies and source code of the fuzzed project. The \texttt{build.sh} script is called inside the container to build the project. The compiled fuzz targets, seed corpora and dictionaries are stored in the output directory (specified by the \texttt{OUT} environment variable) \cite{oss-fuzz-setting}. The build image contains a prebuilt fuzzing engine library, and the \texttt{build.sh} script has to link the fuzz target to a fuzzing engine specified by the environment variable \texttt{LIB\_FUZZING\_ENGINE} \cite{oss-fuzz-setting}. Finally, the results are uploaded to Google Cloud storage bucket \cite{gcp, oss-fuzz-arch}.

ClusterFuzz automatically downloads the fuzz targets from the storage bucket and starts fuzzing. The fuzz targets are run in a Docker container using a minimal \textit{runner} image. The \textit{runner} image is different than the \textit{builder} image. Most notably, any dependencies and shared libraries installed in the \textit{builder} image will not be present in the \textit{runner} image. Therefore, the fuzz targets either have to be built statically, or the dynamic libraries have to be copied to the output directory. The Docker images can be built and tested locally using the OSS-Fuzz scripts \cite{oss-fuzz-github}.

\section{Used fuzzing engines}

OSS-Fuzz supports linking the same fuzz targets to multiple fuzzing engines. Currently supported engines are libFuzzer \cite{libfuzzer}, AFL++ \cite{aflpp} and Honggfuzz \cite{honggfuzz}. All of them are coverage-guided, which means they work by taking an input from the seed corpus, mutating and executing it, checking if code coverage was increased, and if it was, then the generated input is added to the corpus and the whole process repeats.

The concept of a coverage-guided fuzzer was pioneered by the AFL fuzzer \cite{afl}. It approximates the coverage using an array, where the elements are incremented on every jump instruction on an index derived from the combination of source and destination basic block addresses. \cite{afl_technical}. Although this representation is not fully collision-resistant, it provides outstanding performance, compensating for inaccuracy. The fuzzer was based on well-researched techniques, but it packaged them in an easy to use program that required almost no configuration. It has proven to be very efficient and discovered numerous bugs in real-world software \cite{afl}.

\input{figures/aflpp.tex}

The \texttt{libfuzzer} engine is an in-process fuzzer. The tested code is linked with the fuzz target and \texttt{libfuzzer} to produce the resulting fuzzer. The code needs to be compiled with SanitizerCoverage \cite{sancov} to provide the \texttt{libfuzzer} with coverage feedback. At least one additional sanitiser should be added to detect more bugs. The command-line UI of \texttt{libfuzzer} is shown in \autoref{fig:libfuzzer}.
\input{figures/libfuzzer.tex}

The Honggfuzz engine has native multi-threading support. It can accelerate fuzzing using the persistent mode, which means that a single process keeps running and processing the generated data instead of restarting the fuzz target for every new input. It has solid support for various hardware-assisted code coverage monitoring mechanisms.

\input{figures/honggfuzz.tex}
